/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2020                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#include "blade-config.h"
#include "FlatFilter.h"

void
FlatFilter::set_region( uint64_t _r, bool _is_expanded)
{
    region = _r;
    exclusive = _is_expanded;
}

    
FilterResult 
FlatFilter::apply( TraceEvent * _te )
{ 
    if (!is_active())
        return FILTER_OK;
 
    FilterResult result = FILTER_CHILDREN;
    TraceEvent * _p = _te;
       
    if (!exclusive)
    {
        while ( _p != NULL)
        {
            if ( _p->get_region() == region )
            {
                result = FILTER_OK;
                break;
            }
            _p= _p->get_parent();
        }
    }else   
    {
        if (_p != NULL  && _p->get_parent()->get_region() == region)
            return FILTER_DIRECT_CHILDREN;
    }

    return result;
}
    
