/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2020                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#include "blade-config.h"
#include "TraceEventGroupAnalyzer.h"


TraceEventGroupAnalyzer::~TraceEventGroupAnalyzer()
{
    clear_analyzer();
}


void
TraceEventGroupAnalyzer::clear_analyzer()
{
//     for (std::vector<TraceEventRect*>::iterator iter = rects.begin(); iter != rects.end(); ++iter)
//     {
// 	delete (*iter);
//     }
    rects.clear();
    permanent_labels.clear();
    dynamic_labels.clear();
}



bool
TraceEventGroupAnalyzer::probe(std::vector<TraceEvent*>& events)
{
    return false;
}

void
TraceEventGroupAnalyzer::analyze(std::vector<TraceEvent*>& events, int dh, int dw )
{
    location_line_index.clear();
    int curr_loc_index=-1;
    uint64_t _cur_location=(uint64_t)-1;
    group_min = std::numeric_limits<uint64_t>::max();
    group_max = 0;
    for (std::vector<TraceEvent*>::iterator iter = events.begin(); iter != events.end(); ++iter)
    {
        group_min = std::min( group_min, (*iter)->get_start_timestamp());
        group_max = std::max( group_max, (*iter)->get_end_timestamp());
        
        if (_cur_location != (*iter)->get_location() )
	{
	    _cur_location = (*iter)->get_location();
	    curr_loc_index++;
	}
	location_line_index.push_back(curr_loc_index);
        
    }

}
