/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2020                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#include "blade-config.h"
#include <string>
#include <vector>
#include <inttypes.h>
#include <iostream>
#include <stack>
#include <utility>

#include "Trace.h"
#include "TraceEvent.h"

TraceEventPoint::TraceEventPoint( )
{
    te = NULL;
}
  
    
void
TraceEventPoint::init( TraceEvent*_te, uint64_t _t, bool _s, bool _inc)
{
    te = _te;
    timestamp = _t;
    start = _s;
    including = _inc;
}
    
      
std::ostream&
operator<<( std::ostream& out, const TraceEventPoint & _p)
{
    out << "Point:(" << _p.timestamp << "," << ((_p.start)?"s":"f") << "," << ( (_p.including)?"+":"-") << ",[";
    for (std::vector<uint64_t>::const_iterator iter=_p.metric_values.begin(); iter != _p.metric_values.end(); ++iter)
    {
        out << (*iter);
        if (iter+1 != _p.metric_values.end())
            out << ",";
    }
    out << "]" << std::endl;

    return out;
}
    

  
bool
TraceEventPoint::compareTraceEventPoints( const TraceEventPoint a, const TraceEventPoint b)
{
    return a.get_timestamp() < b.get_timestamp();
}



