/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef CUBE_DATA_EXTRACT_H
#define CUBE_DATA_EXTRACT_H
#include "CubeProxy.h"
#include "PluginServices.h"
#include "TabInterface.h"

#include <QMap>
#include <QString>

namespace jengafett_plugin
{
    
    namespace datalib 
    {
    
        class CubeDataExtract
        {
            
        private:
            cube::CubeProxy*    cube;
            uint64_t nloc;
            
            std::vector<cube::Sysres*> arguments;
            
            void
            prepare_arguments(  const  cube::list_of_sysresources&  );
            
            
            
            
        public:
            CubeDataExtract(cube::CubeProxy*);
            ~CubeDataExtract();
            
            void getArguments( const  cube::list_of_sysresources&  , std::vector<double>&  , QMap< double, QString > &, double&);
            
            void
            getData(  const cube::Metric* , const  cube::list_of_cnodes& , std::vector<double>&, std::vector<double>&, double&) const;
            
            
                     
        }; 
    };
};
#endif // TESTPLUGIN1_H
