/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2018                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef JENGA_FETT_TOOLBAR_H
#define JENGA_FETT_TOOLBAR_H

#include <QToolButton>
#include <QLineEdit>
#include <QComboBox>
#include <QToolBar>
#include <QToolButton>
#include <QLabel>
#include "PluginServices.h"



namespace jengafett_plugin
{
    
    namespace gui 
    {
        
        class JengaFettPluginWidget;

        class JengaFettToolBar : public QToolBar
        {
            Q_OBJECT
        public:
            JengaFettToolBar( cubepluginapi::PluginServices* service );
            
            
            void
            setJengaFettPluginWidget( JengaFettPluginWidget* newparent );

            void
            reinit();
            
            void
            showSelf();
            
            void
            hideSelf();
            
            
            
        private slots:


            void
            setAbsolute ( );

            void
            setCommonMax ( );

            void
            setEveryBarMax( );
            
            void
            setLogPlot( );    
            
            void
            setLinearPlot( );  
            
            
        private:
            cubepluginapi::PluginServices*       service;
            JengaFettPluginWidget* parent;
            QAction  *real_values_action;
            QAction  *common_max_action;
            QAction  *every_bar_max_action;
            QAction  *logplot_action;
            QAction  *speedup_action; 
            cube::Metric* speedup_met;
            bool active;
            
            void
            refreshPlot();
            
            
        };

    };
};


#endif
