/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#include "config.h"
#include <iostream>
#include <QFile>
#include <QTextStream>
#include <QStringList>
#include "ScorePionConfigFile.h"

using namespace scorepion_plugin::misc;

ScorePionConfigFile::ScorePionConfigFile( QString & _path):path( _path )
{
  
    filter_file = "";
    
    QFile _file( path );
        
    if (_file.open(QIODevice::ReadOnly))
    {
        QTextStream in(&_file);
        while (!in.atEnd())
        {
            QString line = in.readLine();
            QStringList list = line.split("=");
            QString var = list[0];
            QString value = list[1];
            if ( var == "SCOREP_FILTERING_FILE")
            {
                filter_file = value.trimmed();
                if ( (filter_file[0] =='\'') && (filter_file[ filter_file.length()-1] == '\''))
                {
                    filter_file = filter_file.section('\'', 1,1);
                }
                else 
                    if ( ( filter_file[0] ==  '"'  )&& (filter_file[ filter_file.length()-1] == '"'))
                {
                    filter_file = filter_file.section('"', 1,1);
                }
            }
        }
        _file.close();
    }
}

