/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2018                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __DEFAULT_FILTER_RULES_SET_H
#define __DEFAULT_FILTER_RULES_SET_H 0

#include <vector>
#include "DefaultFilterRule.h"
#include "FilterRulesSet.h"


namespace scorepion_plugin
{
    namespace filters
    {
        class DefaultRulesSet : public FilterRulesSet
        {
            public:
                DefaultRulesSet(): FilterRulesSet(INCLUDE_FILE) 
                {
		        match_result = INCLUDE;
		        FilterRulesSet::AddRule (new DefaultFilterRule( ) );
                };
                virtual
                ~DefaultRulesSet() {};
                
                virtual
                void
                AddRule(  const std::string & rule) 
                {
                    	(void) rule;
                    	FilterRulesSet::AddRule( new DefaultFilterRule( ));
                }
            
        };
    }
 };

#endif
