/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __EXCLUDE_REGION_FILTER_RULES_SET_H
#define __EXCLUDE_REGION_FILTER_RULES_SET_H 0

#include <vector>
#include "FilterRulesSet.h"
#include "ExcludeRegionNameFilterRule.h"

namespace scorepion_plugin
{
    namespace filters
    {
        class ExcludeRegionFilterRulesSet : public FilterRulesSet
        {
            public:
                ExcludeRegionFilterRulesSet(): FilterRulesSet(EXCLUDE_REGION) {match_result = INCLUDE;};
                virtual
                ~ExcludeRegionFilterRulesSet() {};
                
                virtual
                void
                AddRule(  const std::string & rule) 
                {
                    FilterRulesSet::AddRule( new ExcludeRegionNameFilterRule( rule ));
                }
                
                
//                 virtual 
//                 void
//                 print(std::ostream& ) const;
//   
//                 friend
//                 std::ostream& 
//                 operator<< (std::ostream&, const ExcludeRegionFilterRulesSet&);
            
        };
    }
 };

#endif
