/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#include "config.h"
#include <FiltersChain.h>

using namespace scorepion_plugin::filters;

FiltersChain::FiltersChain() 
{
    
}


FiltersChain::~FiltersChain() 
{
}


FilterResult
FiltersChain::apply(cube::Vertex * _v) const
{
    FilterResult result = INCLUDE;
    for ( std::list<FilterRulesSet*>::const_iterator iter = sets.begin(); iter != sets.end(); ++iter)
    {
        FilterResult _result =  (*iter)->apply( _v );
        result = ( _result != NO_MATCH )? _result:result;
    }
    return result;
}
            

void
FiltersChain::print(std::ostream& out) const
{
    if (sets.size() != 0)
    {
//                 std::string indent = "\t";
//                 indent = "\t\t";
        for (std::list<FilterRulesSet*>::const_iterator iter = sets.begin(); iter != sets.end(); ++iter)
        {
//                     out << indent;
            (*iter)->print(out);
            out << std::endl;
        }
    }
    
}
    
    
std::ostream& 
FiltersChain::operator<< (std::ostream& out) const
{
    print( out );
    return out;
}
    
