/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2018                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef __FILTERS_FACTORY_H
#define __FILTERS_FACTORY_H 0

#include <list>
#include <fstream>

#include <QString>
#include "FilterRulesSet.h"


namespace scorepion_plugin
{
    namespace filters
    {

        class ScorePionFiltersFactory
        {
        protected:

            std::list<FilterRulesSet *> filter_sets;
            std::list<FilterRulesSet *> default_filter_sets;
            
        public:
            ScorePionFiltersFactory(  ) ;
            
            std::list<FilterRulesSet *>&
            getFilterSets();
            
                        
            std::list<FilterRulesSet *>&
            getDefaultFilterSets();
            
            void
            readFilterFile(QString& filterfile);
            
            

        };
    }
 };

#endif
